// -*- C++ -*-
/*!
 * @file  ClueReader.h
 * @brief Clue Reader component
 * @date  $Date$
 *
 * $Id$
 */

#ifndef CLUEREADER_H
#define CLUEREADER_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>

//Header File for QR Code reader
#include "QD25.h"
using namespace RTC;

class ClueReader
  : public RTC::DataFlowComponentBase
{
 public:
   ClueReader(RTC::Manager* manager);
   ~ClueReader();
   
   //This state is Initialize routine for Serial Communication
   virtual RTC::ReturnCode_t onInitialize();
   
   //This state is Finalize routine for Clue Reader
   virtual RTC::ReturnCode_t onFinalize();

   //This state is Initialize routine for Clue Reader
  //   virtual RTC::ReturnCode_t onActivated();

   //In this state, Clue Data is output to the OutPort
   virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

 protected:

   TimedCharSeq m_ClueData;
   OutPort<TimedCharSeq> m_ClueDataOut;
   
 private:
   QD25 qd;

};


extern "C"
{
  void ClueReaderInit(RTC::Manager* manager);
};

#endif // CLUEREADER_H
