#include"QD25.h"

bool QD25::Initialize(){
  //Initialize of QD25 and RS232C Communication
  QD25Base::Initialize(COMPORT);
  usleep(500);

  //Set Unread check mode
  #ifdef UNREADCHK
  if(!SetUnreadCheckMode(0)){
    std::cout<<"Cannot Set Unread Check Mode"<<std::endl;
    return false;
  }
  #else
  if(!SetUnreadCheckMode(1)){
    std::cout<<"Cannot Set Unread Check Mode"<<std::endl;
    return false;
  }
  #endif

  //Trun off the Buzzer when the code can be readed
  #ifdef BUZZEROFF
  usleep(1000000);
  if(!SetBuzzerMode(1)){
    std::cout<<"Cannot Set Buzzer mode"<<std::endl;
    return false;
  }
  usleep(1000000);
  if(!SetFaleBeepMode(1)){
    std::cout<<"Cannot Set Fale Beep mode"<<std::endl;
    return false;
  }
  #else
  usleep(1000000);
  if(!SetBuzzerMode(0)){
    std::cout<<"Cannot Set Buzzer mode"<<std::endl;
    return false;
  }
  usleep(1000000);
  if(!SetFaleBeepMode(0)){
    std::cout<<"Cannot Set Fale Beep mode"<<std::endl;
    return false;
  }  
  #endif

  //Set code read mode
  //In this case, "Read Mode" is set to Soft Trigger Mode
  usleep(1000000);
  if(!SetReadMode(4)){
    std::cout<<"Cannnot set read mode"<<std::endl;
    return false;
  }

  usleep(1000000);
  #ifdef SYNC
  //Set the Synchronous mode
  if(!SetSynchronousMode(1)){
    std::cout<<"Cannnot set synchronous mode"<<std::endl;
    return false;
  }
  #else
  if(!SetSynchronousMode(0)){
    std::cout<<"Cannnot set synchronous mode"<<std::endl;
    return false;
  }
  #endif
  

  #ifdef OUT
  //Set Mark corner Position Output
  usleep(1000000);
  if(!SetMarkPositionOutput(1)){
    std::cout<<"Cannot set Mark Position Output"<<std::endl;
    return false;
  }
  #else
	usleep(1000000);
  if(!SetMarkPositionOutput(0)){
    std::cout<<"Cannot set Mark Position Output"<<std::endl;
    return false;
  }  
  #endif
  std::cout<<"Initialize OK!!"<<std::endl;

  return true;
}

void QD25::Finalize(){
  QD25Base::Finalize();
}

int QD25::ReadQRCodeData(char *data){
  int length;
  string checkdata;

  //Trun on the Soft Trigger
  SoftTriggerOn();
  //Sleep 
  usleep(1000000);
  //Turn of the Soft Trigger
  SoftTriggerOff();
  length = ReceiveCodeData(data);
  if(length < 0){
    std::cout<<"Cannnot Read QR Code Data"<<std::endl;
    return -1;
  }
  else{
    std::cout<<"Receive Byte:"<<length<<std::endl;
  }
  return length;
}
