//Serial Communication Class
//This Class ingerited Serial Communication Class
//Programed by Kenichi Ohara, AIST

#include"SerialCom.h"

//Initialize of Serial Communication
//This function sets general parameter for serial communication
bool SerialCom::Initialize(const char *dev,int BaudRate)
{
  if(!OpenCOMDevice("/dev/ttyUSB0"))
  {
    cout<<"OpenCOMDevice Error!"<<endl;
    return false;
  }

  //Set baud rate
  SetBaudRate(BaudRate);

  //Set data bit
  SetDataBit(8);

  //Set the Stop Bit to '1'
  ClearStopBit2();

  //Parity Setting
  //NONPARITY
  SetParityFlag(NOPARITY);

  //Enable RX Read
  EnableRead();

  //set canonical mode
  EnableCanonical();

  //Set receive delimiter to ICRNL
  SetReceiveDelimiter(CRNL);
  return true;
}

//Finalization Process for Serial Communication
bool SerialCom::Finalize()
{
  //Close com device port
  CloseCOMDevice();
  return true;
}


//Receive Method
//This method creates the special thread for receive message.
int SerialCom::Receive(char *buffer)
{
  int length;
  length = ReceiveMessage(buffer);
  return length;
}
